# sed scritpts to create chfcreate exported function files
# this sed program is used in pkgcreate.ch

# it will get the function prototypes like
#    extern MagickExport rettype func (type arg);

/extern.*MagickExport/!d

# process line if extern MagickExport is present 
/extern.*MagickExport/{

    # bring the whole function prototype into one line
    :loop
    /;/!{ 
      # if )); is not found, it will match next line
      N

      # remove return line '\n' and spaces " " between lines
      s/\n */ /

      # go back to loop
      b loop
    }

    # Remove 'extern MagickExport'
    # \1 refers to rettype, \2 refers to func, \3 refers to (type arg)
    # [^)] means to match the first ")" 
    s/extern\(.*\)MagickExport\(.*\);/\1 \2;/

    # Remove 'magick_attribute((*))' function from the files
    /magick_attribute/d
} 
